



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>C入门---位运算</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">C入门---位运算</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-23 14:56:12 </span>
						</div>
										<div class="post-content">
											
		<p>程序中的所有数在计算机内存中都是以二进制的形式储存的。位运算直接对整数在内存中的二进制位进行操作。由于位运算直接对内存数据进行操作，不需要转成十进制，因此处理速度非常快。</p>
<p><strong>（1），与（&amp;）运算</strong></p>
<p>"&amp;"运算通常用于二进制取位操作，例如一个数 &amp; 1 的结果就是取二进制的最末位。这可以用来判断一个整数的奇偶，二进制的最末位为0表示该数为偶数，最末位为1表示该数为奇数。</p>
<p><strong>（2），或（|）运算</strong></p>
<p>”|“运算通常用于二进制特定位上的无条件赋值，例如一个数 | 1 的结果就是把二进制最末位强行变成1。如果需要把二进制最末位变成0，对这个数| 1之后再减1就可以了，其实际意义就是把这个数强行变成最接近的偶数。</p>
<p><strong>（3），异或（^）运算</strong></p>
<p>"^"运算通常用于对二进制的特定一位进行取反操作，因为异或可以这样定义： 0和1 异或0都不变，异或1则取反。</p>
<p>"^"运算的逆运算是它本身，也就是说两次异或同一个数最后结果不变，即（a^b)^b = a。”^"运算可以用于简单的加密，比如你想对一个朋友说1314520，但怕别人知道，于是双方约定拿生日19800205作为密钥，1314520 ^ 19800205 = 20590165, 于是就把20590165告诉这个朋友。你的朋友再次计算20590165^19800205的值，得到1314520，于是它就明白了你的意图。</p>
<p>加法和减法互为逆运算，并且加法满足交换律。可以写出一个不需要临时变量的swap函数</p>
<p>void swap(int a, int b)</p>
<p>{</p>
<p>a = a + b;</p>
<p>b = a - b;</p>
<p>a = a - b;</p>
<p>}</p>
<p>由于^的逆运算是它本身，于是就有了一个很特别的swap过程：</p>
<p>void swap(int a, int b)</p>
<p>{</p>
<p>a = a ^ b;</p>
<p>b = a ^ b;</p>
<p>a = a ^ b;</p>
<p>}</p>
<p><strong>（4），取反（~）运算</strong></p>
<p>“~”运算的定义是把内存中的0和1全部取反。使用“~”运算时要格外小心，需要注意整数类型有没有符号。如果“~”的对象是无符号整数（不能表示负数），那么得到的值就是它与该类型上界的差。因为无符号类型的数是用00到$FFFF依次表示的。下面的程序返回65435。</p>
<p>#include &lt;stdio.h&gt;</p>
<p>int main()</p>
<p>{</p>
<p>unsigned short a = 100;</p>
<p>a = ~a;</p>
<p>printf("%d\n",a);</p>
<p>return 0;</p>
<p>}</p>
<p>如果“~”的对象是有符号的整数，情况就不一样了， 稍后会提到。</p>
<p><strong>（5），左移（&lt;&lt;）运算</strong></p>
<p>a &lt;&lt; b 表示把 a 转为二进制后左移 b 位（在后面添b个0）。如100的二进制为1100100,而110010000转成十进制是400.可以看出 a&lt;&lt; b的值实际上就是a 乘以 2的 b次方，因为在二进制数后面添加一个0 就相当于该数乘以2.</p>
<p>通常认为 a &lt;&lt;1 比 a * 2更快，因为前者是更底层的操作，因此程序中乘以2的操作请尽量用左移一位来代替。</p>
<p>定义一些常量可能会用到 &lt;&lt;运算。可以方便地用（1 &lt;&lt; 16) -1来表示65535.很多算法和数据结构要求数据规模必须是2的幂，此时可以用&lt;&lt;来定义Max_N等常量。</p>
<p><strong>（6），右移（&gt;&gt;)运算</strong></p>
<p>和&lt;&lt;相似，a &gt;&gt; b 表示二进制右移b位（去掉末b位），相当于a除以2的b次方（取整）。此外也经常用 &gt;&gt; 1来代替除以2，比如二分查找， 堆的插入操作等。想办法用&gt;&gt;代替除法运算，可以使程序效率大大提高。最大公约数的二进制算法用除以2操作来代替mod运算，效率可以提高60%。</p>
<p>常见的二进制位的变换操作</p>
<table>
<tbody>
<tr>
<td>功能</td>
<td>示例</td>
<td>位运算</td>
</tr>
<tr>
<td>去掉最后一位</td>
<td>（101101---&gt;10110）</td>
<td>&nbsp;x &gt;&gt; 1</td>
</tr>
<tr>
<td>在最后加一个0</td>
<td>（101101---&gt;1011010）</td>
<td>&nbsp;x &lt;&lt; 1</td>
</tr>
<tr>
<td>在最后加一个1</td>
<td>（101101---&gt;1011011）</td>
<td>（x &lt;&lt; 1) + 1</td>
</tr>
<tr>
<td>把最后一位变成1</td>
<td>（101100---&gt;101101）</td>
<td>x | 1</td>
</tr>
<tr>
<td>把最后一位变成0</td>
<td>（101101---&gt;101100）</td>
<td>(x|1)-1</td>
</tr>
<tr>
<td>最后一位取反</td>
<td>（101101---&gt;101100）</td>
<td>x ^ 1</td>
</tr>
<tr>
<td>把右数第k位变成1</td>
<td>（101001---&gt;101101, k = 3）</td>
<td>x | (1 &lt;&lt; (k -1))</td>
</tr>
<tr>
<td>把右数第k位变成0</td>
<td>(101101---&gt;101001，k = 3)</td>
<td>x &amp; ~(1 &lt;&lt;(k -1))</td>
</tr>
<tr>
<td>右数第K位取反</td>
<td>（101001---&gt;101101，K= 3）</td>
<td>&nbsp;x ^(1 &lt;&lt; (k - 1))</td>
</tr>
<tr>
<td>取末位三位</td>
<td>（1101101---&gt;101）</td>
<td>x &amp; 7&nbsp;</td>
</tr>
<tr>
<td>取末K位</td>
<td>（1101101---&gt;1101，k = 5）</td>
<td>x &amp; ((1 &lt;&lt; k ) -1)</td>
</tr>
<tr>
<td>取右数第 k位</td>
<td>（1101101---&gt;1, k = 4）</td>
<td>&nbsp;x &gt;&gt;(k -1) &amp;1</td>
</tr>
<tr>
<td>把末K位变成1</td>
<td>（101001---&gt;101111， k = 4）</td>
<td>&nbsp;x | ((1 &lt;&lt; k ) -1)</td>
</tr>
<tr>
<td>末K位取反</td>
<td>（101001---&gt;100110， k = 4）</td>
<td>x ^ ((1&lt;&lt;k ) - 1)</td>
</tr>
<tr>
<td>去掉整数最右边的1</td>
<td>（100101111---&gt;10010110）</td>
<td>x &amp; ( x - 1)</td>
</tr>
<tr>
<td>把右边连续的1变成0</td>
<td>（100101111---&gt;100100000）</td>
<td>&nbsp;x &amp; ( x + 1)</td>
</tr>
<tr>
<td>把右起第一个0 变成1</td>
<td>（100101111---&gt;100111111）</td>
<td>&nbsp;x | (x + 1)</td>
</tr>
<tr>
<td>把右边连续的0变成1</td>
<td>（11011000---&gt;11011111）</td>
<td>&nbsp;x | (x - 1)</td>
</tr>
<tr>
<td>去掉右起第一个1 的左边</td>
<td>（100101000---&gt;1000）</td>
<td>
<p>x &amp; (x ^(x -1))</p>
</td>
</tr>
<tr>
<td>取右边连续的1</td>
<td>（100101111---&gt;1111）</td>
<td>
<p>（x ^(x+1)) &gt;&gt; 1</p>
</td>
</tr>
</tbody>
</table>
<p>在实际的编程过程中，往往会用一个整数的不同位表示不同的数据信息。在访问该整数时，就需要通过位运算来获得或者改变整数的某几位数值。比如在windows中创建时使用的create数据结构：</p>
<p>struct{</p>
<p>PIO_SECURITY_CONTEXT SecurityCOntext;</p>
<p>ULONG Options;</p>
<p>USHORT POINTER_ALIGNMENT FileAttributes;</p>
<p>USHORT ShareAccess;</p>
<p>ULONG POINTER_ALIGNMENT Ealength;</p>
<p>PVOID EaBuffer;</p>
<p>LARGE_INTEGER AllocationSize;</p>
<p>}Create;</p>
<p>通常会引用其中的Options 如下：</p>
<p>Data-&gt;Iopb-&gt;Parameters.Create.Options</p>
<p>ULONG Options 是一个Windows文件创建过程中的无符号长整数，指示在创建和打开文件时的不同选项。其中高8位指示了CreateDisposition参数（如FILE_OPEN, FILE_CREATE), 低24位指示了CreateOptions参数（如FILE_DELETE_ON_CLOSE）。</p>
<p>为了得到CreateDisposition的值，采取下面的位操作：</p>
<p>（Data-&gt;Iopb-&gt;Parameters.Create.Options &gt;&gt; 24) &amp; 0x000000ff;</p>
<p>将该整数右移24位，再与0xff进行与操作， 即可获得CreateDisposition的值。</p>
<p>（2）将第n 位置位或清零。</p>
<p>#define BITN (1 &lt;&lt; n)</p>
<p>置位： a |= BITN;</p>
<p>清零： a &amp;= ~BITN;</p>
<p>(3)清除整数a最右边的1</p>
<p>方法： a &amp; (a -1)</p>
<p>问题： 如何判断整数x的二进制中含有多少个1？</p>
<p>int func(x)</p>
<p>{</p>
<p>int countx = 0;</p>
<p>while(x)</p>
<p>{</p>
<p>countx ++;</p>
<p>x = x &amp; (x -1);</p>
<p>}</p>
<p>return countx;</p>
<p>}</p>
<p>(4)将一个整数对齐到n:</p>
<p>a = (a + n -1) &amp; ~(n -1)</p>																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/o8k6d0jq.html">JMeter处理jdbc请求后的响应结果</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rdz6rr8.html">Mac OS finder &colon; 显示和隐藏文件&lbrack;夹&rsqb; show and hide files or folders</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j0wo54q.html">Android listview 的优化</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydpdxxq.html">从ora10g 刷数据到 8I基本操作步骤</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zd61n9.html">Linux文件系统，ntfs分区显示只读文件系统，提示超级快损坏</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me0ly6q.html">Java基础系列--08&lowbar;集合1</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdl26y9.html">XYZZY spfa  最长路 判环</a>
		</li>
						<li><a href="https://www.batexi.com/a/qllnoy0q.html">冒泡排序Java版</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyy5xpjq.html">【问题与解决】Mac OS通过 npm 安装 React Native 报错（checkPermissions Missing write access to &sol;usr&sol;local&sol;lib&sol;node&lowbar;modules）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gnvwvq.html">recovery 升级过程LED灯闪烁</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r5xmmdq.html">xdoj-1243 &lpar;费马平方和问题）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mjjdgr8.html">Scala 闭包</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zkwv0x8.html">ubuntu桌面安装常用软件&amp;amp&semi;及常见问题</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ko7kk6q.html">WebDriverException&colon; Message&colon; A session is either terminated or not started</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnd1xy28.html">python学习（二十二） Python 中boolean</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odpd4eq.html">java JDBC与MySQL 关于日间与日期</a>
		</li>
						<li><a href="https://www.batexi.com/a/8odz5w5q.html">微信企业号升级企业微信后zabbix告警发不出去</a>
		</li>
						<li><a href="https://www.batexi.com/a/95p6nreq.html">Educational Codeforces Round 34 C&period; Boxes Packing【模拟&sol;STL-map&sol;俄罗斯套娃】</a>
		</li>
						<li><a href="https://www.batexi.com/a/q774rvkq.html">linux设备驱动程序之并发和竞态（二）</a>
		</li>
						<li><a href="https://www.batexi.com/a/967zoky8.html">【hihocoder 1329】&Tab;平衡树&CenterDot;Splay&lpar;set做法&rpar;</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/e9pgme79.html">html&comma; xhtml和xml</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mklw2q.html">JVM 垃圾回收器工作原理及使用实例介绍&lpar;转载自IBM&rpar;，直接复制粘贴&comma;需要原文戳链接</a>
			</li>
						<li><a href="https://www.batexi.com/a/390yep38.html">sed命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvk0jo9.html">Android IOS WebRTC 音视频开发总结（八十七）-- WebRTC中丢包重传NACK实现分析</a>
			</li>
						<li><a href="https://www.batexi.com/a/oqvk0oo9.html">location&period;hash详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/49gg57l9.html">NSSortDescriptor对象进行数组排序</a>
			</li>
						<li><a href="https://www.batexi.com/a/jqdkz7v9.html">标准bootstrap html 页面</a>
			</li>
						<li><a href="https://www.batexi.com/a/wq144o5q.html">curl post方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/r9373xn8.html">html5&plus;css 图片自适应</a>
			</li>
						<li><a href="https://www.batexi.com/a/49ggzdz9.html">TStringHelper的相关知识、Helper相关细节</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
